<?php

date_default_timezone_set('Etc/GMT-4');

function russian_date($timestamp) {
	$date = explode(".", date("d.n.Y.H.i.s", $timestamp));
	$months = array(1 => 'января', 'февраля', 'марта', 'апреля', 'мая', 'июня', 'июля', 
			'августа', 'сентября', 'октября', 'ноября', 'декабря');
	$m = $months[$date[1]];
	return($date[0] . '&nbsp;' . $m . '&nbsp;' . $date[2] . ',&nbsp;' . 
		$date[3] . ':' . $date[4] . ':' . $date[5]);
}


function decode_unicode_url($str){
	$res = '';

	$i = 0;
	$max = strlen($str) - 6;
	while ($i <= $max) {
		$character = $str[$i];
		if ($character == '%' && $str[$i + 1] == 'u') {
			$value = hexdec(substr($str, $i + 2, 4));
			$i += 6;

			if ($value < 0x0080) // 1 byte: 0xxxxxxx
				$character = chr($value);
			else if ($value < 0x0800) // 2 bytes: 110xxxxx 10xxxxxx
				$character = chr((($value & 0x07c0) >> 6) | 0xc0). 
					chr(($value & 0x3f) | 0x80);
			else // 3 bytes: 1110xxxx 10xxxxxx 10xxxxxx
				$character = chr((($value & 0xf000) >> 12) | 0xe0) . 
					chr((($value & 0x0fc0) >> 6) | 0x80) . 
					chr(($value & 0x3f) | 0x80);
		} else
			$i++;

		$res .= $character;
	}

	return $res . substr($str, $i);
}

function get_timezone_offset($remote_tz, $origin_tz = null) {
    if($origin_tz === null) {
        if(!is_string($origin_tz = date_default_timezone_get())) {
            return false; // A UTC timestamp was returned -- bail out!
        }
    }
    $origin_dtz = new DateTimeZone($origin_tz);
    $remote_dtz = new DateTimeZone($remote_tz);
    $origin_dt = new DateTime("now", $origin_dtz);
    $remote_dt = new DateTime("now", $remote_dtz);
    $offset = $origin_dtz->getOffset($origin_dt) - $remote_dtz->getOffset($remote_dt);
    return $offset;
}

?>
