<?php
	header("Cache-Control: no-cache");
	header("Pragma: no-cache");
	header('Content-type: text/html; charset=utf-8');
?>


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html style="height:100%; margin-right:0px; margin-left:0px; margin-top:0px; margin-bottom:0px;">
	<head>
		<title>
			Оперативный просмотр
		</title>
	
		<script type="text/javascript" src="jquery/jquery-1.7.2.min.js"></script> 
		<script type="text/javascript" src="jquery/jquery-ui-1.8.18.custom.min.js"></script>

		<script type="text/javascript" src="vargus.js"></script>

	        <link type="text/css" href="jquery/jquery-ui-1.8.18-lightness.css" rel="stylesheet">

		<link type="text/css" href="vargus.css" rel="stylesheet">

	</head>
	<body style="height:100%; margin-right:0px; margin-left:0px; margin-top:0px; margin-bottom:0px;">
<?php
	function ask_vargus($query) {
		$answer = explode("\n", `echo "query $query" |netcat localhost 9165 |grep -E "^[^:>]"`);

		if (! $answer) {
			die("Ошибка получения информации о видеосистеме");
		}
		return $answer;
	}


	if (isset($_GET['set'])) { 
		$use_set = $_GET['set']; 
	} else {
		$use_set = 1; 
	}

	if (isset($_GET['view'])) {
		$use_view = $_GET['view'];
	} else {
		$use_view = 1; 
	}

	if (isset($_GET['full'])) {
		$show_full = $_GET['full'];
	} else {
		$show_full = 0; 
	}

	$host=$_SERVER["HTTP_HOST"];
	$my_name = $_SERVER["SCRIPT_NAME"];


# Sets processing


	list($sets_quantity) = ask_vargus('set;quantity');
	if ($use_set > $sets_quantity) { 
		error_log("Set '$use_set' is greater than quantity of sets '$sets_quantity', use last");
		$use_set = $sets_quantity;
	}


	$sets_info = array();
	$sets_raw = array();

	$cell_of_sets = "<table cellspacing=0 cellpadding=3><tr>\n";

	$sets_raw = ask_vargus("set;" . implode(",", range(1, $sets_quantity)) . ";description,cameras");


	for ($set = 1; $set < count($sets_raw); $set++ ) {
		list($sets_info[$set]["description"], $sets_info[$set]["cameras"]) = explode(';', $sets_raw[$set - 1]);
		$selected = '';
		if ($set == $use_set) $selected = " class='selected'";
		$cell_of_sets .= "
						  <td$selected onClick='document.location=\"http://$host$my_name?set=$set&view=\" + use_view'
							style='cursor:pointer;'> 
							<span class='menu'><nobr>
							&nbsp;&nbsp;&nbsp;&nbsp;" . $sets_info[$set]['description'] . "&nbsp;&nbsp;&nbsp;&nbsp;
							</nobr></span>
						  </td>
						  ";
	}
	$cell_of_sets .= "</tr></table>
		<script>
		var sets_md5 = [];
	";
	for ($set = 1; $set < count($sets_raw); $set++ ) {
		$cell_of_sets .= "sets_md5[$set] = '" . md5($sets_info[$set]["cameras"]) . "';
		";
	}
	$cell_of_sets .= "</script>";


# Views processing

	list($views_quantity) = ask_vargus('view;quantity');
	if ($use_view > $views_quantity) { 
		error_log("View '$use_view' is greater than quantity of views '$views_quantity', use last");
		$use_view = $views_quantity;
	}

	$views_info = array();
	$views_raw = array();

	$views_raw = ask_vargus("view;" . 
		implode(",", range(1, $views_quantity)) . 
		";description,name,geometry:width,geometry:height,geometry:double,geometry:triple");

	$cell_of_views = "
			<script>
				var use_view = $use_view;
				var use_set = $use_set;
				var show_full = $show_full;
				var views = [];
				var views_quantity = $views_quantity;
	";

	for ($view = 1; $view < count($views_raw); $view++ ) {
		list(
			$views_info[$view]["description"], 
			$views_info[$view]["name"], 
			$views_info[$view]["width"],
			$views_info[$view]["height"],
			$views_info[$view]["double"],
			$views_info[$view]["triple"]
		) = explode(';', $views_raw[$view - 1]);


		unset($multipliers);
		$multipliers = array();
		for ($view_item = 1; $view_item <= $views_info[$view]["width"] * $views_info[$view]["height"]; $view_item++) {
			$multipliers[$view_item] = 1;
		}

		if ($views_info[$view]["double"]) {
			foreach (explode(',', $views_info[$view]["double"]) as $view_item) {
				$multipliers[$view_item] = 2;
			}
		}

		if ($views_info[$view]["triple"]) {
			foreach (explode(',', $views_info[$view]["triple"]) as $view_item) {
				$multipliers[$view_item] = 3;
			}
		}

		$cell_of_views .= "
			views[$view] = {
				description: '" . $views_info[$view]["description"] . "',
				name: '" . $views_info[$view]["name"] . "',
				width: '" . $views_info[$view]["width"] . "',
				height: '" . $views_info[$view]["height"] . "',
				multiplier: [" . implode(',', $multipliers) . "],
				md5: '" . md5($views_raw[$view - 1]) . "'
			}
		 ";
	}

		$cell_of_views .= "
				  </script>
		";
		
	$uri = preg_replace('/\?.*/', '', $_SERVER['REQUEST_URI']);
	for ($view = 1; $view <= $views_quantity; $view++ ) {
		$onclick = $show_full ? 
			"document.location = '$uri?set=$use_set&view=$view'" :
			"applyView($view)";
		$cell_of_views .= "&nbsp;<canvas id='view_icon_$view' width=40 height=30 title='" .   
			$views_info[$view]["description"] . "' onClick=\"$onclick\" style='cursor:pointer'
			style='margin-left:45px; margin-right:15px;'>" . 
				$views_info[$view]['name'] . "
			</canvas>&nbsp;";
	}


# Cameras processing


	$cameras_quantity = 0;
	$i = 0;
	$cameras_info = array();
	$cameras_raw = ask_vargus("camera;" . $sets_info[$use_set]['cameras'] . ";name,description,view:source,view:preview,events:agent");

	for ($camera = 1; $camera < count($cameras_raw); $camera++ ) {
		list(
			$cameras_info[$camera]['id'],
			$cameras_info[$camera]['description'],
			$cameras_info[$camera]['source'],
			$cameras_info[$camera]['preview'],
			$cameras_info[$camera]['has_events']
		) = explode(';', $cameras_raw[$camera - 1]);
		$cameras_info[$camera]['obj_id'] = $cameras_info[$camera]['id'];
		$cameras_info[$camera]['id'] = str_replace("cam", "", $cameras_info[$camera]['id']);
	}
	$cameras_quantity = count($cameras_raw) - 1;


	$cell_of_list = "
			  <script>
              var cameras = [];
              var cam_element = [];
              var cameras_quantity = $cameras_quantity;
	      var events_data = [];
	      for (i=1; i<= $cameras_quantity + 1; i++) {
		      events_data[i] = '&nbsp;';
	      }
	 ";


	for ($cam = 1; $cam <= $cameras_quantity; $cam++) {
		$event_param = "";
		if ($cameras_info[$cam]['has_events']) $event_param = "events=$cam&";
		$cam_element = 
			"<a class='camera' id='cam$cam' href='" . 
			$cameras_info[$cam]['source'] . "' title='Камера $cam: " . 
			$cameras_info[$cam]['description'] . "'>".
			"<div style='position:relative; width:100%; height:100%'>" . 
			"<img id='img$cam' src='" . $cameras_info[$cam]['preview'] . 
			"' height=100% width=100% border=0>" . 
			"<div class='tools' align=center>&nbsp;<table class='tooltab' cellpadding=5><tr><td width=100%>&nbsp;</td>" . 
			"<td align=right><div class='archive' id='ar_" . $cameras_info[$cam]['obj_id'] . "' title='Архив'>A</div></td>" . 
			"</tr></table></div>" .
			"<div class='cammark'>&nbsp;$cam.&nbsp;" . $cameras_info[$cam]['description'] . "</div>" .
			"<div class='events' id='events_cam$cam' width=100% height=100%>&nbsp;</div>" .
			"</div></a>";
				
		$cell_of_list .= "
			cameras[$cam] = {
				id: '" . $cameras_info[$cam]['id'] . "',
				obj_id: '" . $cameras_info[$cam]['obj_id'] . "',
				description: '" . $cameras_info[$cam]['description'] . "',
				source: '" . $cameras_info[$cam]['source'] . "',
				preview: '" . $cameras_info[$cam]['preview'] . "'";
		if ($cameras_info[$cam]['has_events']) {
			$cell_of_list .= ",
				has_events: 1";
		}
		$cell_of_list .= "
			}
			cam_element[$cam] = \"$cam_element\";
		";
	}

	
	$cam_element = "<a rel='view' class='camera' id='cam0' title='Нет камеры'></a>";
	$cell_of_list .= "
				cam_element[0] = \"$cam_element\";
			  </script>
	 ";


	for ($cam = 1; $cam <= $cameras_quantity; $cam++) {
		$event_param = "";
		if ($cameras_info[$cam]['has_events']) $event_param = "events=$cam&";
		$cell_of_list .=" 
		 <tr class='camlist' id='cam_list_$cam'>
			<td align=right style='padding-top:6px; padding-bottom:6px;' >$cam.</td>
			<td style='padding-top:6px; padding-bottom:6px;'><nobr>" . $cameras_info[$cam]['description'] . "</nobr></td>
		 </tr>
			  ";
	}
				
?>









<!--	HTML document structure -->




<table cellspacing=0 cellpadding=0 width=100% height='100%'>
	<tr>
		<td width=100% class='bground'>
			<table cellspacing=0 cellpadding=0 width=100% height=100%>
				<tr>
				  <td> <!-- navcell -->
					  <div id='navbar'>
						  <table cellspacing=0 cellpadding=0 width=100%>
							  <tr>
								  <td width=50%>
									  <?php print($cell_of_sets); ?>
								  </td>
								  <td width=50%'>
									  <div align=center>
										  &nbsp;
									  </div>
								  </td>
							  </tr>
						  </table>
					  </div>
					</td> <!-- End navcell -->
				</tr>
				<tr>     <!-- cameras area -->
				  <td height=100% id="cell_of_cameras" class='fground'>
					  &nbsp;
				  </td>
			  </tr>
		  </table>
		</td>

		<td width=150 height=100% valign=top class='bground'>
			<table cellpadding=0 cellspacing=0>
				<tr>
					<td>&nbsp;&nbsp;</td>
					<td>
						<br><br>
					  <div align=center>
								 <?php print($cell_of_views); ?>
							<br>
							<table width=100% border=0><tr>
							 <td width=33% align=center>
								  <canvas id='control_prev' width=40 height=30 title='Предыдущие камеры' 
									  onClick='scrollPrev()' style='cursor:pointer'>
									  Предыдущие камеры
								  </canvas>
							 </td>
							 <td width=33% align=center>
								  <canvas id='control_reset' width=40 height=30 title='Сброс' 
									  onClick='scrollReset()' style='cursor:pointer'>
									  Сброс
								  </canvas>
							 </td>
							 <td width=33% align=center>
								  <canvas id='control_next' width=40 height=30 title='Следующие камеры' 
									  onClick='scrollNext()' style='cursor:pointer'>
									  Следующие камеры
								  </canvas>
							 </td>
							</tr></table>
					  </div>
					  <table cellpadding=2 cellspacing=0 width=100% style='margin-right:10px'>
						  <?php print($cell_of_list); ?>
					  </table>
					</td>
					<td>&nbsp;&nbsp;</td>
				</tr>
			</table>
		</td>
	</tr>
</table>




<script>
	var optimal_single_x;
	var optimal_single_y;
	var cell_counter = 0;
	var cam_assigment = [];
	var cam_offset = 0;
	var moved_camera;
	var move_type = '';
	var original_cell = 0;


	var bgcolor = getStyleByClass('bground').backgroundColor;
	var fgcolor = getStyleByClass('fground').backgroundColor;
	var selcolor = getStyleByClass('selected').backgroundColor;


	function first_view() {
		applyView(use_view);
		if (show_full == 0) {
			for (i = 1; i <= cameras_quantity; i++) {
				if (cameras[i]["has_events"]) load_events(i, "");
			}
		}
	}


	$(document).ready(first_view);
</script>

</body>
</html>

